#!/usr/bin/python
# -*- coding: utf-8 -*-
#########################################################################
## This scaffolding model makes your app work on Google App Engine too
#########################################################################

try:
    from gluon.contrib.gql import *  # if running on Google App Engine
except:
    db = SQLDB('sqlite://storage.db')  # if not, use SQLite or other DB
else:
    db = GQLDB()  # connect to Google BigTable
    session.connect(request, response, db=db)  # and store sessions there
    # or use the following lines to store sessions in Memcache
    #from gluon.contrib.memdb import MEMDB
    #from google.appengine.api.memcache import Client
    #session.connect(request, response, db=MEMDB(Client()))

#########################################################################
## uncomment the following line if you do not want sessions
#session.forget()
#########################################################################

#########################################################################
## Define your tables below, for example
##
## >>> db.define_table('mytable',SQLField('myfield','string'))
##
## Fields can be 'string','text','password','integer','double','booelan'
##       'date','time','datetime','blob','upload', 'reference TABLENAME'
## There is an implicit 'id integer autoincrement' field
## Consult manual for more options, validators, etc.
##
## More API examples for controllers:
##
## >>> db.mytable.insert(myfield='value')
## >>> rows=db(db.mytable.myfield=='value).select(db.mytable.ALL)
## >>> for row in rows: print row.id, row.myfield
#########################################################################
db.define_table('Questions',db.Field('auteur_id','integer',writable=False),
                            db.Field('description','text'),
                            db.Field('visibilite','boolean',default=True),
                            db.Field('resultat',default='{}',writable=False),
                            db.Field('nbr_votes','integer',default=0,writable=False),
                            db.Field('date_postee','datetime',default=request.now,writable=False),
                            db.Field('date_limite','datetime'))
db.Questions.description.requires=IS_NOT_EMPTY()

db.define_table('Reponses',db.Field('Q_id',db.Questions,writable=False),
                           db.Field('titre'),
                           db.Field('visibilite','boolean',default=True),
                           db.Field('resultat',writable=False),
                           db.Field('date_postee','datetime',default=request.now,writable=False))
db.Reponses.titre.requires=IS_NOT_EMPTY() 

                                 
db.define_table('Tags',db.Field('titre','string'))
db.Tags.titre.requires=[IS_NOT_EMPTY(),IS_NOT_IN_DB(db,'Tags.titre')]

db.define_table('Tags_Questions',db.Field('Q_id',db.Questions,writable=False),
                                 db.Field('T_id',db.Tags))
#db.Tags_Questions.T_id.requires=IS_NOT_IN_DB(db.Tags_Questions.Q_id,'Tags_Questions.T_id')
#,IS_IN_DB(db,'Tags.id','Tags.titre')]                                 
db.Tags_Questions.T_id.requires=IS_IN_DB(db,'Tags.id','%(titre)s')
Tagged_Questions=(db.Questions.id==db.Tags_Questions.Q_id)&(db.Tags.id==db.Tags_Questions.T_id)

db.define_table('Votes',db.Field('Q_id',db.Questions),
                        db.Field('U_id'),
                        db.Field('D_id',default=None),
                        db.Field('Buletin'),
                        db.Field('date_vote','datetime',default=request.now,writable=False))                        
#db.Votes.D_id.requires=IS_IN_DB(db,'Delegues.id','Delegues.nom')

#########################################################################
## Here is sample code if you need:
## - email capabilities
## - authentication (registration, login, logout, ... )
## - authorization (role based authorization)
## - crud actions
## uncomment as needed
#########################################################################

from gluon.tools import Mail, Auth, Crud     # new in web2py 1.56
#mail=Mail()                                  # mailer
#mail.settings.server='smtp.gmail.com:587'    # your SMTP server
#mail.settings.sender='jm.fauche@free.fr'         # your email
#mail.settings.login='username:password'      # your credentials

auth=Auth(globals(),db)                      # authentication/authorization
auth.settings.table_user = db.define_table(
auth.settings.table_user_name,db.Field('first_name', length=128,default='',requires=IS_NOT_EMPTY()),
                              db.Field('last_name', length=128,default='',requires=IS_NOT_EMPTY()),
                              db.Field('email', length=128,default=''),
                              db.Field('password', 'password', readable=False,label='Password', requires=[CRYPT(),IS_NOT_EMPTY()]),
                              db.Field('registration_key', length=128,writable=False, readable=False,default=''))
auth.settings.table_user.email.requires = [IS_EMAIL(), IS_NOT_IN_DB(db, '%s.email' % auth.settings.table_user._tablename)]


#auth.settings.mailer=mail                    # for user email verification
auth.define_tables()# creates all needed tables
## ?? auth.auth_user.password.requires=[CRYPT(),IS_NOT_EMPTY()]
auth.messages.registration_successful='Vous vous êtes Enregistré avec succès, Bienvenue dans Demexp !'
auth.messages.logged_in='Connecté'
auth.messages.logged_out='Déconnecté'
auth.messages.access_denied = 'Insufficient privileges'
auth.messages.email_sent = 'Email envoyé'
auth.messages.email_verified = 'Email vérifié'
auth.messages.invalid_email = 'Email non valide'
auth.messages.invalid_login = 'Login non valide'
auth.messages.mismatched_password = "Les mots de passes sont différents"
auth.messages.verify_email = \
            'Cliquez sur le lien http://...verify_email/%(key)s pour vérifier votre Email'
auth.messages.verify_email_subject = 'Password verify'
auth.messages.username_sent = "Votre nom d'utilisateur vous a été envoyé par Email"
auth.messages.new_password_sent = 'Un nouveau mot de passe vous a été envoyé par Email'
auth.messages.password_changed = 'Mot de passe changé'
auth.messages.retrieve_username = "Votre nom d'utilisateur est: %(username)s"
auth.messages.retrieve_username_subject = "Nom d'utilisateur retrouvé"
auth.messages.retrieve_password = 'Votre mot de passe est: %(password)s'
auth.messages.retrieve_password_subject = 'Mot de passe retrouvé'
auth.messages.profile_updated = 'Profil mis à jour'
auth.messages.new_password='Nouveau mot de passe'
auth.messages.old_password='Ancien mot de passe'

#crud=Crud(globals(),db)                      # for CRUD helpers using auth
#crud.settings.auth=auth                      # (optional) enforces authorization on crud

if auth.is_logged_in():db.Questions.auteur_id.default = auth.user.id                      


#########################################################################
## then, to expose authentication
## http://..../[app]/default/user/login
## http://..../[app]/default/user/logout
## http://..../[app]/default/user/register
## http://..../[app]/default/user/profile
## http://..../[app]/default/user/retrieve_password
## http://..../[app]/default/user/change_password
## use the following action in controller default.py
##
##     def user(): return dict(form=auth())
##
## read docs for howto create roles/groups, assign memberships and permissions
##
## to expose CRUD
## http://..../[app]/default/data/tables
## http://..../[app]/default/data/select/[table]
## http://..../[app]/default/data/create/[table]
## http://..../[app]/default/data/read/[table]/[id]
## http://..../[app]/default/data/update/[table]/[id]
## http://..../[app]/default/data/delete/[table]/[id]
## use the following action in controller default.py
##
##     def data(): return dict(form=crud())
##
## to allow automatic download of all uploaded files and enforce authorization
## use the following action in controller default.py
##
##     def download(): return response.download(request,db)
##